# coding: utf-8

"""
    IONOS Cloud - DNS API

    Cloud DNS service helps IONOS Cloud customers to automate DNS Zone and Record management.   # noqa: E501

    The version of the OpenAPI document: 1.17.0
    Contact: support@cloud.ionos.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud_dns.configuration import Configuration


class DnssecKeyReadListMetadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'zone_id': 'str',

        'items': 'list[DnssecKey]',
    }

    attribute_map = {

        'zone_id': 'zoneId',

        'items': 'items',
    }

    def __init__(self, zone_id=None, items=None, local_vars_configuration=None):  # noqa: E501
        """DnssecKeyReadListMetadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._zone_id = None
        self._items = None
        self.discriminator = None

        if zone_id is not None:
            self.zone_id = zone_id
        if items is not None:
            self.items = items


    @property
    def zone_id(self):
        """Gets the zone_id of this DnssecKeyReadListMetadata.  # noqa: E501

        The ID (UUID) of the DNS zone of which record belongs to.  # noqa: E501

        :return: The zone_id of this DnssecKeyReadListMetadata.  # noqa: E501
        :rtype: str
        """
        return self._zone_id

    @zone_id.setter
    def zone_id(self, zone_id):
        """Sets the zone_id of this DnssecKeyReadListMetadata.

        The ID (UUID) of the DNS zone of which record belongs to.  # noqa: E501

        :param zone_id: The zone_id of this DnssecKeyReadListMetadata.  # noqa: E501
        :type zone_id: str
        """

        self._zone_id = zone_id

    @property
    def items(self):
        """Gets the items of this DnssecKeyReadListMetadata.  # noqa: E501


        :return: The items of this DnssecKeyReadListMetadata.  # noqa: E501
        :rtype: list[DnssecKey]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this DnssecKeyReadListMetadata.


        :param items: The items of this DnssecKeyReadListMetadata.  # noqa: E501
        :type items: list[DnssecKey]
        """

        self._items = items
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DnssecKeyReadListMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DnssecKeyReadListMetadata):
            return True

        return self.to_dict() != other.to_dict()
